"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.session = void 0;
const mongoose_1 = require("mongoose");
const keys_1 = require("./keys");
const session = (sessionOptions) => {
    const options = Object.assign({ sessionName: 'session', collectionName: 'sessions', sessionKeyFn: keys_1.getSessionKey }, sessionOptions);
    const sessionSchema = new mongoose_1.Schema({ key: String, data: Object }, { collection: options.collectionName });
    const collection = mongoose_1.model('Session', sessionSchema);
    const saveSession = (key, data) => collection.updateOne({ key }, { $set: { data } }, { upsert: true });
    const getSession = (key) => __awaiter(void 0, void 0, void 0, function* () { var _a, _b; return (_b = (_a = (yield collection.findOne({ key }))) === null || _a === void 0 ? void 0 : _a.data) !== null && _b !== void 0 ? _b : {}; });
    const { sessionKeyFn: getKey, sessionName } = options;
    return (ctx, next) => __awaiter(void 0, void 0, void 0, function* () {
        const key = getKey(ctx);
        const data = key == null ? undefined : yield getSession(key);
        ctx[sessionName] = data;
        yield next();
        if (ctx[sessionName] != null) {
            yield saveSession(key, ctx[sessionName]);
        }
    });
};
exports.session = session;
